from wx.lib.mixins.inspection import InspectableApp

from wxToolbarTestUI import WXToolbarTestUI


class WXToolbarTestFrame(WXToolbarTestUI):
    def on_copy(self, event):
        self.FindFocus().Copy()

    def update_copy(self, event):
        widget = self.FindFocus()
        if widget and hasattr(widget, "CanCopy"):
            event.Enable(widget.CanCopy())
        else:
            event.Enable(False)

    def on_cut(self, event):
        self.FindFocus().Cut()

    def update_cut(self, event):
        widget = self.FindFocus()
        if widget and hasattr(widget, "CanCut"):
            event.Enable(widget.CanCut())
        else:
            event.Enable(False)

    def on_paste(self, event):
        self.FindFocus().Paste()

    def update_paste(self, event):
        widget = self.FindFocus()
        if widget and hasattr(widget, "CanPaste"):
            event.Enable(widget.CanPaste())
        else:
            event.Enable(False)




class App(InspectableApp):
    def OnInit(self):
        frame = WXToolbarTestFrame(None)
        self.SetTopWindow(frame)
        print("Print statements go to this stdout window by default.")
        print("Press Ctrl-Alt-I (Cmd-Opt-I on Mac) to launch the Widget Inspector.")
        self.InitInspection()
        frame.Show(True)
        return True


app = App(redirect=True)
app.MainLoop()
